workflow:
  rules:
    - if: $CI_COMMIR_BRANCH != "main"
      when: never
    - when: always

stages:
  - test
  - build
  - deploy


run_unit_tests:
  stage: test
  before_script:
    - echo "Preparing test data ..."
  script:
    - echo "Running unit tests.."
  after_script:
    - echo "Cleaning up temporary files ..."

run_lint_tests:
  stage: test
  before_script:
    - echo "Preparing test data ..."
  script:
    - echo "Running lint test.."
  after_script:
    - echo "Cleaning up temporary files ..."

build_image:
  stage: build
  script:
    - echo "Building docker image"
    - echo "Tagging the docker image ..."

push_image:
  stage: build
  needs:
    - build_image
  script:
    - echo "Logging into docker registry ..."
    - echo "Pushing docker image to registry ..."

deploy_image:
  stage: deploy
  script:
    - echo "Deploying docker image to dev server ..."
